<script setup lang="ts">
import interact from 'interactjs'
import { storeToRefs } from 'pinia'
import { useAccountStore } from '~~/store/account'
import { useUIStore } from '~~/store/UI'

const ui = useUIStore()
const { isMobile, designNumber, sideBar, isDesign7, overlay } = storeToRefs(ui)
const target = ref(null)
const account = useAccountStore()
const { full } = storeToRefs(account)

// resize left
onMounted(() => {
  const { width } = useWindowSize()
  interact('.resizeLeft').resizable({
    edges: {
      top: false,
      left: true,
      bottom: false,
      right: false,
    },
    listeners: {
      move(event) {
        Object.assign(event.target.style, {
          width: `${Math.max(Math.min(event.rect.width, width.value / 3), 300)}px`,
        })
      },
    },
  })
})

onUnmounted(() => {
  interact('.resizeLeft').unset()
})

// onClickOutside(target, () => {
//   if (isMobile.value)
//     mTabFull.value = false
// })
</script>

<template>
  <div>
    <AMobileCss v-if="isMobile" />

    <OZoomModal />
    <div class="rootGrid" gap-2 grid-flow-col grid :data-design="designNumber" :data-side="sideBar">
      <div class="slot1">
        <MTopBar :class="{ '-translate-y-full': (isDesign7 && !overlay), 'relative': isDesign7 }" />
      </div>
      <slot name="left" />
      <div
        class="slot5"
        flex flex-row bg-neutral-900 lt-sm="justify-center items-center flex-row gap-2"
      >
        <AComboWait class="pl-3 gap-2 mb-1" />
        <AIconsPortal class="flex-1" lt-sm="h-15 w-270px flex-none" />
        <div flex flex-1 lt-sm="flex-none min-w-2 pl-4">
          <slot name="bottom" />
        </div>
      </div>
      <div
        ref="target" w-96
        class="resizeLeft slot4"
        lt-sm="w-full"
      >
        <slot />
      </div>
    </div>
  </div>
</template>

<style lang="scss">
.rootGrid{
  position: absolute;
  top: 0;
  left: 0;
  width: 100vw;
  height: 100vh;
  max-height: -webkit-fill-available;
  max-width: 100%;
  pointer-events: none;
  > * {
    pointer-events: auto;
  }
  > .slot2{
    pointer-events: none;
  }
  // max-width: 100vw;
  // max-height: 100vh;
  &[data-design="1"]{
    grid-template: auto 1fr auto 50px / 1fr auto;
    >.slot1{
      grid-area: 1 / 1 / 2 / 3;
    }
    >.slot2{
      grid-area: 2 / 1 / 3 / 2;
    }
    >.slot3{
      grid-area: 3 / 1 / 4 / 2;
    }
    >.slot4{
      grid-area: 2 / 2 / 4 / 3;
    }
    >.slot5{
      grid-area: 4 / 1 / 5 / 3;
    }
  }
  &[data-design="2"]{
    grid-template: auto 1fr 50px / 1fr auto;
    >.slot1{
      grid-area: 1 / 1 / 2 / 3;
    }
    >.slot2{
      grid-area: 2 / 1 / 3 / 2;
    }
    >.slot3{
      display: none;
    }
    >.slot4{
      grid-area: 2 / 2 / 3 / 3;
    }
    >.slot5{
      grid-area: 3 / 1 / 4 / 3;
    }
    >.slot6{
      display: none;
    }
  }
  &[data-design="3"]{
    grid-template: auto 1fr 50px / auto;
    >.slot1{
      grid-area: 1 / 1 / 2 / 2;
    }
    >.slot2{
      grid-area: 2 / 1 / 3 / 2;
    }
    >.slot3{
      display: none;
    }
    >.slot4{
      display: none;
    }
    >.slot5{
      grid-area: 3 / 1 / 4 / 2;
    }
  }
  &[data-design="4"]{
    grid-template: auto 1fr auto auto auto  / auto;
    >.slot1{
      grid-area: 1 / 1 / 2 / 2;
    }
    >.slot2{
      grid-area: 2 / 1 / 3 / 2;
    }
    >.slot3{
      grid-area: 4 / 1 / 5 / 2;
    }
    >.slot4{
      grid-area: 5 / 1 / 6 / 2;
    }
    >.slot5{
      grid-area: 3 / 1 / 4 / 2;
    }
  }
  &[data-design="5"]{
    grid-template: auto 1fr 1fr/ auto;
    >.slot1{
      grid-area: 1 / 1 / 2 / 2;
    }
    >.slot2{
      grid-area: 2 / 1 / 3 / 2;
    }
    >.slot3{
      display: none;
    }
    >.slot4{
      grid-area: 3 / 1 / 4 / 2;
    }
    >.slot5{
      display: none;
    }
    >.slot6{
      display: none;
    }
  }
  &[data-design="6"]{
    grid-template: auto 1fr/ auto;
    >.slot1{
      grid-area: 1 / 1 / 2 / 2;
    }
    >.slot2{
      grid-area: 2 / 1 / 3 / 2;
    }
    >.slot3{
      display: none;
    }
    >.slot4{
      display: none;
    }
    >.slot5{
      display: none;
    }
  }
  &[data-design="7"]{
    grid-template: auto 1fr 50px/ 3fr 2fr;
    >.slot1{
      grid-area: 1 / 1 / 2 / 3;
    }
    >.slot2{
      grid-area: 1 / 1 / 4 / 3;
    }
    >.slot3{
      display: none;
    }
    >.slot4{
      display: none;
    }
    >.slot5{
      display: none;
    }
    &[data-side=true]{
      >.slot4{
        z-index: 2;
        grid-area: 2 / 2 / 4 / 3;
        display: block;
      }
    }
  }
}
@media only screen and (max-width: 600px) {
  .rootGrid{
    grid-template: auto 3fr 1fr 1fr auto/1fr;
  }
}
</style>
